
print("Tip 1:\t\t", type(1))
print("Tip 1.0:\t", type(1.0))
print("Tip 'blabla':\t", type("blabla"))
print("Tip [1, 2, 3]:\t", type([1, 2, 3]))


# Začetki - naredimo class brez funkcionalnosti

class Kaca: #Uporabljamo Camel case
    pass #Kjer bo koda še bila...

# Instantizacija razreda - Ko je prostor alociran objektu / inštanca pa pomeni, da so vrednosti postavljene v spomin/prostor 
# ki je bil dodeljen
kaca = Kaca() 
print(kaca)

# Gremo naprej - dodamo atribute

class Kaca:
    ime = "python" # set an attribute `name` of the class

kaca = Kaca()
print(kaca.ime)

# Gremo še naprej - Dodajmo metode
# Ko imamo enkrat atribute, ki pripadajo razredu, lahko definiramo funkcije ki bodo dostopale do teh atributov - to so metode
# 'method' is the object-oriented word for 'function'
# Prvi argument metode vedno self

class Kaca:
    ime = "python"
    
    def spremeni_ime(self, novo_ime): # prvi argument je self - predstavlja inštanco objekta samega. 
        #Večina objektno usmerjenih jezikov sproži to kot skriti parameter v metodo definirano v objektu.
        #Pri Pythonu moramo za to poskrbeti sami..
        self.ime = novo_ime # dostop do atributa razreda z self
 
kaca = Kaca()
# print trenutno ime 
print(kaca.ime)

# change the name using the change_name method
kaca.spremeni_ime("anakonda")
print(kaca.ime)

#______________________________________________________________
# Sprintajmo še enkrat

class Kaca:

    def __init__(self, ime):
        self.ime = ime

        # __init__ metoda pa predstavlja na nek način konstruktor razreda v Pythonu

        #Konstruktor je metoda razreda v računalniškem programiranju, ki poskrbi za udejanjenje tega razreda (instantizacijo). 
        #Konstruktor poskrbi za stvaritev objekta razrednega tipa in nastavitev prvotnih vrednosti (inicializacija).

    def spremeni_ime(self, novo_ime):
        self.ime = novo_ime

python = Kaca("python")
anakonda = Kaca("anakonda")

print(python.ime)
print(anakonda.ime)

#______________________________________________________________

class Vozilo:
    #Razred je kot omenjeno template za kreiranje objektov
    def __init__(self, tip, st_koles, st_sedezev, prostornina, moc):
        self.tip = tip
        self.st_koles = st_koles
        self.st_sedezev = st_sedezev
        self.prostornina = prostornina
        self.moc = moc
    
    def __str__(self): # to je toString operacija, ki poskrbi za človeku prijazen izpis objekta 
        return f"Jaz sem vozilo tipa {self.tip}, vozim se na {self.st_koles} kolesih in sprejmem {self.st_sedezev} potnikov. " + \
                f"Pri prostornimi {self.prostornina} ccm zgeneriram {self.moc} konjev."
        
sportni = Vozilo("športni", 4, 2, 3000, 300) #objekt je narejen z uporabo konstruktorja razreda, klican pa je kot inštanca razreda
print(sportni)

#______________________________________________________________
#Nadgradnja vozila

class Vozilo:
    def __init__(self, tip, st_koles, st_sedezev, prostornina, moc):
        self.tip = tip
        self.st_koles = st_koles
        self.st_sedezev = st_sedezev
        self.prostornina = prostornina
        self.moc = moc
        
        # druge lastnosti
        self.trenutno_v_vozilu = 0
    
    def __str__(self):
        return f"Jaz sem vozilo tipa {self.tip}, vozim se na {self.st_koles} kolesih in sprejmem {self.st_sedezev} potnikov. " + \
                f"Pri prostornimi {self.prostornina} ccm zgeneriram {self.moc} konjev."
        
    def vstop_potnika(self, koliko=1):
        if self.trenutno_v_vozilu + koliko > self.st_sedezev:
            print("Ni dovolj sedežev!")
        else:
            self.trenutno_v_vozilu += koliko
            print(f"Dodanih {koliko} potnikov. Trenutno je v vozilu {self.trenutno_v_vozilu} potnikov.")
        
    
    def odpelji(self):
        if self.trenutno_v_vozilu == 0:
            print("Ne morem odpeljati, ni šoferja!")
        else:
            print(f"Vrum, vrum! Odpeljal sem {self.trenutno_v_vozilu} potnikov.")

sportni = Vozilo("športni", 4, 2, 3000, 300)
sportni.odpelji()
sportni.vstop_potnika()
sportni.odpelji()
sportni.vstop_potnika(2)

# POVEZOVANJE NA BAZO

class DatabaseManager:
    def __init__(self, host, ime_baze, user, password):
        self.host = host
        self.ime_baze = ime_baze
        self.user = user
        self.password = password
        
        print('Baza kreirana!')
    
    def connect(self):
        # Tukaj bi se povezali na bazo, če smo neuspešni vrnemo ERR, sicer vrnemo True (konkretno je seveda odvisno od implementacije)
        # Mi bomo samo napisali, da je bila povezava uspešna.
        print (f"Povezava na bazo {self.ime_baze} uspešna!")
    
    def disconnect(self):
        # tu pride prava implementacija
        print (f"Uspešno ste prekinili povezavo z bazo {self.ime_baze}!")
        
    def poizvedba(self, query):
        # prvo se povežemo na bazo
        self.connect()
        
        # tu pride implementacija
        print(f"Uspešno ste na bazi {self.ime_baze} izvedli poizvedbo '{query}'")
        # vrnemo neke arbitrarne podatke
        resp = {'status': 200, 'data': {'title': 'Hello KŠK!', 'body': 'To so simulirani podatki iz baze!'}}
        return resp
        #print(resp)

db = DatabaseManager("127.0.0.1", "moja_baza", "kšk", "5up3rG3510")
podatki = db.poizvedba('SELECT * FROM znanje_programiranja')

status = podatki['status']
print("Status: " + str(status)) 

print(f"Status: {podatki['status']}")
print(f"Naslov: {podatki['data']['title']}")
print(f"Besedilo: {podatki['data']['body']}")
db.disconnect()